import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { ShopCount, ShopCountParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询商城销售统计表
 */
export async function pageShopCount(params: ShopCountParam) {
  const res = await request.get<ApiResult<PageResult<ShopCount>>>(
    MODULES_API_URL + '/mall/shop-count/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询商城销售统计表列表
 */
export async function listShopCount(params?: ShopCountParam) {
  const res = await request.get<ApiResult<ShopCount[]>>(
    MODULES_API_URL + '/mall/shop-count',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加商城销售统计表
 */
export async function addShopCount(data: ShopCount) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/mall/shop-count',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改商城销售统计表
 */
export async function updateShopCount(data: ShopCount) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/mall/shop-count',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除商城销售统计表
 */
export async function removeShopCount(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/mall/shop-count/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除商城销售统计表
 */
export async function removeBatchShopCount(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/mall/shop-count/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询商城销售统计表
 */
export async function getShopCount(id: number) {
  const res = await request.get<ApiResult<ShopCount>>(
    MODULES_API_URL + '/mall/shop-count/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
